/* Pentru fiecare pozitie i, sa se determine minimul valorilor
 * secventei care se termina la poz i si are lungime cel mult K
 * 
 * 1 <= n, K <= 100000
 * Algoritmul naiv (brute force)
 */ 
#include <fstream>
#include <vector>
#include <deque>
#include <algorithm>
using namespace std; 

ifstream fin("secventa.in");
ofstream fout("secventa.out");


// Dorim determinam minimul pe o secventa de lungime cel mult K 
// care se temina la pozitia i
// 

// Ex: K = 3
//   8    7    1    5    4    2    6    -1
// a[0] a[1] a[2] a[3] a[4] a[5] a[6]  a[7]
//                            i
 
const int Dim = 1000, Inf = 1e9; // 1*10^9
int a[Dim], n, K;

void CitesteSir();
void Rezolva();
 
 
int main()
{
	CitesteSir();
	Rezolva();
}

void Rezolva() // O(n^2)
{
	int v_min = Inf;
	
	for (int i  = 1; i <= n; ++i)
	{
		v_min = Inf;
		for (int j = 0; j < K && i - j >= 1; ++j)
			v_min = min(v_min, a[i - j]);
				
		fout << v_min <<  ' ';
	}
}

void CitesteSir()
{
	fin >> n >> K;
	
	for (int i = 1; i <= n; ++i)
		fin >> a[i];
	
}


